diff --git a/board/freescale/b4860qds/b4860qds.c b/board/freescale/b4860qds/b4860qds.c
index 6a8fca6..0831cda 100644
--- a/board/freescale/b4860qds/b4860qds.c
+++ b/board/freescale/b4860qds/b4860qds.c
@@ -1213,7 +1213,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_liodn(blob);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/bsc9131rdb/bsc9131rdb.c b/board/freescale/bsc9131rdb/bsc9131rdb.c
index 75e1142..c3be910 100644
--- a/board/freescale/bsc9131rdb/bsc9131rdb.c
+++ b/board/freescale/bsc9131rdb/bsc9131rdb.c
@@ -73,7 +73,9 @@ int ft_board_setup(void *blob, bd_t *bd)
 	fdt_fixup_mtdparts(blob, nodes, ARRAY_SIZE(nodes));
 #endif
 
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 	return 0;
 }
diff --git a/board/freescale/bsc9132qds/bsc9132qds.c b/board/freescale/bsc9132qds/bsc9132qds.c
index 586dacc..61f96f8 100644
--- a/board/freescale/bsc9132qds/bsc9132qds.c
+++ b/board/freescale/bsc9132qds/bsc9132qds.c
@@ -394,7 +394,9 @@ int ft_board_setup(void *blob, bd_t *bd)
 			/* remove dts usb node */
 			fdt_del_node_compat(blob, "fsl-usb2-dr");
 		} else {
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 			fdt_fixup_dr_usb(blob, bd);
+#endif
 			fdt_del_node_and_alias(blob, "serial2");
 		}
 	}
diff --git a/board/freescale/corenet_ds/corenet_ds.c b/board/freescale/corenet_ds/corenet_ds.c
index 2945339..77f33c2 100644
--- a/board/freescale/corenet_ds/corenet_ds.c
+++ b/board/freescale/corenet_ds/corenet_ds.c
@@ -208,6 +208,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_liodn(blob);
 
+#ifdef CONFIG_USB_DEVTREE_FIXUP
+	fdt_fixup_dr_usb(blob, bd);
+#endif
+
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
 	fdt_fixup_board_enet(blob);
diff --git a/board/freescale/ls2080aqds/ls2080aqds.c b/board/freescale/ls2080aqds/ls2080aqds.c
index aa256a2..6b3a15e 100644
--- a/board/freescale/ls2080aqds/ls2080aqds.c
+++ b/board/freescale/ls2080aqds/ls2080aqds.c
@@ -300,6 +300,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 		return err;
 #endif
 
+#ifdef CONFIG_USB_DEVTREE_FIXUP
+	fdt_fixup_dr_usb(blob, bd);
+#endif
+
 	return 0;
 }
 #endif
diff --git a/board/freescale/ls2080ardb/ls2080ardb.c b/board/freescale/ls2080ardb/ls2080ardb.c
index c63b639..5f1d886 100644
--- a/board/freescale/ls2080ardb/ls2080ardb.c
+++ b/board/freescale/ls2080ardb/ls2080ardb.c
@@ -266,6 +266,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 		return err;
 #endif
 
+#ifdef CONFIG_USB_DEVTREE_FIXUP
+	fdt_fixup_dr_usb(blob, bd);
+#endif
+
 	return 0;
 }
 #endif
diff --git a/board/freescale/mpc8308rdb/mpc8308rdb.c b/board/freescale/mpc8308rdb/mpc8308rdb.c
index 93e1c50..266f70a 100644
--- a/board/freescale/mpc8308rdb/mpc8308rdb.c
+++ b/board/freescale/mpc8308rdb/mpc8308rdb.c
@@ -164,7 +164,11 @@ int misc_init_r(void)
 int ft_board_setup(void *blob, bd_t *bd)
 {
 	ft_cpu_setup(blob, bd);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
+
 	fdt_fixup_esdhc(blob, bd);
 
 	return 0;
diff --git a/board/freescale/mpc8315erdb/mpc8315erdb.c b/board/freescale/mpc8315erdb/mpc8315erdb.c
index ed611c5..85cc45e 100644
--- a/board/freescale/mpc8315erdb/mpc8315erdb.c
+++ b/board/freescale/mpc8315erdb/mpc8315erdb.c
@@ -194,7 +194,9 @@ int ft_board_setup(void *blob, bd_t *bd)
 #ifdef CONFIG_PCI
 	ft_pci_setup(blob, bd);
 #endif
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 	fdt_tsec1_fixup(blob, bd);
 
 	return 0;
diff --git a/board/freescale/mpc837xemds/mpc837xemds.c b/board/freescale/mpc837xemds/mpc837xemds.c
index 572913c..5107934 100644
--- a/board/freescale/mpc837xemds/mpc837xemds.c
+++ b/board/freescale/mpc837xemds/mpc837xemds.c
@@ -332,7 +332,9 @@ int ft_board_setup(void *blob, bd_t *bd)
 {
 	ft_cpu_setup(blob, bd);
 	ft_tsec_fixup(blob, bd);
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 	fdt_fixup_esdhc(blob, bd);
 #ifdef CONFIG_PCI
 	ft_pci_setup(blob, bd);
diff --git a/board/freescale/mpc837xerdb/mpc837xerdb.c b/board/freescale/mpc837xerdb/mpc837xerdb.c
index 565f815..a17c0e1 100644
--- a/board/freescale/mpc837xerdb/mpc837xerdb.c
+++ b/board/freescale/mpc837xerdb/mpc837xerdb.c
@@ -210,7 +210,9 @@ int ft_board_setup(void *blob, bd_t *bd)
 	ft_pci_setup(blob, bd);
 #endif
 	ft_cpu_setup(blob, bd);
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 	fdt_fixup_esdhc(blob, bd);
 
 	return 0;
diff --git a/board/freescale/mpc8536ds/mpc8536ds.c b/board/freescale/mpc8536ds/mpc8536ds.c
index 7b0f461..017ed99 100644
--- a/board/freescale/mpc8536ds/mpc8536ds.c
+++ b/board/freescale/mpc8536ds/mpc8536ds.c
@@ -281,7 +281,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 	fsl_sgmii_riser_fdt_fixup(blob);
 #endif
 
-#ifdef CONFIG_HAS_FSL_MPH_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/p1010rdb/p1010rdb.c b/board/freescale/p1010rdb/p1010rdb.c
index ebffe9a..77ad58a 100644
--- a/board/freescale/p1010rdb/p1010rdb.c
+++ b/board/freescale/p1010rdb/p1010rdb.c
@@ -462,7 +462,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_memory(blob, (u64)base, (u64)size);
 
-#if defined(CONFIG_HAS_FSL_DR_USB)
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/p1022ds/p1022ds.c b/board/freescale/p1022ds/p1022ds.c
index d7dd478..7d49738 100644
--- a/board/freescale/p1022ds/p1022ds.c
+++ b/board/freescale/p1022ds/p1022ds.c
@@ -344,7 +344,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_memory(blob, (u64)base, (u64)size);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/p1023rdb/p1023rdb.c b/board/freescale/p1023rdb/p1023rdb.c
index 074b713..af81fbf 100644
--- a/board/freescale/p1023rdb/p1023rdb.c
+++ b/board/freescale/p1023rdb/p1023rdb.c
@@ -142,7 +142,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_memory(blob, (u64)base, (u64)size);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/p1_p2_rdb_pc/p1_p2_rdb_pc.c b/board/freescale/p1_p2_rdb_pc/p1_p2_rdb_pc.c
index 61b7a91..0247149 100644
--- a/board/freescale/p1_p2_rdb_pc/p1_p2_rdb_pc.c
+++ b/board/freescale/p1_p2_rdb_pc/p1_p2_rdb_pc.c
@@ -453,7 +453,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 #endif
 
-#if defined(CONFIG_HAS_FSL_DR_USB)
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/p1_twr/p1_twr.c b/board/freescale/p1_twr/p1_twr.c
index a40bea3..bfdcfa0 100644
--- a/board/freescale/p1_twr/p1_twr.c
+++ b/board/freescale/p1_twr/p1_twr.c
@@ -282,7 +282,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #if defined(CONFIG_TWR_P1025)
 	fdt_board_fixup_qe_pins(blob);
 #endif
+
+#ifdef CONFIG_HAS_FSL_DR_USB
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 	return 0;
 }
diff --git a/board/freescale/p2041rdb/p2041rdb.c b/board/freescale/p2041rdb/p2041rdb.c
index e600bdb..250ab08 100644
--- a/board/freescale/p2041rdb/p2041rdb.c
+++ b/board/freescale/p2041rdb/p2041rdb.c
@@ -227,7 +227,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_memory(blob, (u64)base, (u64)size);
 
-#if defined(CONFIG_HAS_FSL_DR_USB) || defined(CONFIG_HAS_FSL_MPH_USB)
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/t102xqds/t102xqds.c b/board/freescale/t102xqds/t102xqds.c
index 708afca..a6a14cf 100644
--- a/board/freescale/t102xqds/t102xqds.c
+++ b/board/freescale/t102xqds/t102xqds.c
@@ -379,7 +379,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_liodn(blob);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/t102xrdb/t102xrdb.c b/board/freescale/t102xrdb/t102xrdb.c
index fddd240..bd648e1 100644
--- a/board/freescale/t102xrdb/t102xrdb.c
+++ b/board/freescale/t102xrdb/t102xrdb.c
@@ -194,7 +194,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
diff --git a/board/freescale/t1040qds/t1040qds.c b/board/freescale/t1040qds/t1040qds.c
index eaca57f..33e69dd 100644
--- a/board/freescale/t1040qds/t1040qds.c
+++ b/board/freescale/t1040qds/t1040qds.c
@@ -261,7 +261,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_liodn(blob);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/t104xrdb/t104xrdb.c b/board/freescale/t104xrdb/t104xrdb.c
index 3227652..e2487e6 100644
--- a/board/freescale/t104xrdb/t104xrdb.c
+++ b/board/freescale/t104xrdb/t104xrdb.c
@@ -149,7 +149,7 @@ int ft_board_setup(void *blob, bd_t *bd)
 
 	fdt_fixup_liodn(blob);
 
-#ifdef CONFIG_HAS_FSL_DR_USB
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
 #endif
 
diff --git a/board/freescale/t208xqds/t208xqds.c b/board/freescale/t208xqds/t208xqds.c
index 7c89cd5..539d1ee 100644
--- a/board/freescale/t208xqds/t208xqds.c
+++ b/board/freescale/t208xqds/t208xqds.c
@@ -467,7 +467,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
diff --git a/board/freescale/t208xrdb/t208xrdb.c b/board/freescale/t208xrdb/t208xrdb.c
index 0c2c1c5..49548d4 100644
--- a/board/freescale/t208xrdb/t208xrdb.c
+++ b/board/freescale/t208xrdb/t208xrdb.c
@@ -134,7 +134,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
diff --git a/board/freescale/t4qds/t4240emu.c b/board/freescale/t4qds/t4240emu.c
index 5441094..d1acee2 100644
--- a/board/freescale/t4qds/t4240emu.c
+++ b/board/freescale/t4qds/t4240emu.c
@@ -82,7 +82,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 	fdt_fixup_memory(blob, (u64)base, (u64)size);
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 	return 0;
 }
diff --git a/board/freescale/t4qds/t4240qds.c b/board/freescale/t4qds/t4240qds.c
index 4f2cccd..7ac705e 100644
--- a/board/freescale/t4qds/t4240qds.c
+++ b/board/freescale/t4qds/t4240qds.c
@@ -700,7 +700,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
diff --git a/board/freescale/t4rdb/t4240rdb.c b/board/freescale/t4rdb/t4240rdb.c
index fac442b..09a2231 100644
--- a/board/freescale/t4rdb/t4240rdb.c
+++ b/board/freescale/t4rdb/t4240rdb.c
@@ -105,7 +105,10 @@ int ft_board_setup(void *blob, bd_t *bd)
 #endif
 
 	fdt_fixup_liodn(blob);
+
+#ifdef CONFIG_USB_DEVTREE_FIXUP
 	fdt_fixup_dr_usb(blob, bd);
+#endif
 
 #ifdef CONFIG_SYS_DPAA_FMAN
 	fdt_fixup_fman_ethernet(blob);
diff --git a/include/configs/B4860QDS.h b/include/configs/B4860QDS.h
index 9fb5cee..e5b3d66 100644
--- a/include/configs/B4860QDS.h
+++ b/include/configs/B4860QDS.h
@@ -773,6 +773,7 @@ unsigned long get_board_ddr_clk(void);
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #ifdef CONFIG_HAS_FSL_DR_USB
diff --git a/include/configs/BSC9131RDB.h b/include/configs/BSC9131RDB.h
index 4b5ad0e..698f760 100644
--- a/include/configs/BSC9131RDB.h
+++ b/include/configs/BSC9131RDB.h
@@ -381,6 +381,7 @@ extern unsigned long get_sdram_size(void);
 #define CONFIG_SHA_HW_ACCEL
 #endif
 
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_USB_EHCI
 
 #ifdef CONFIG_USB_EHCI
diff --git a/include/configs/BSC9132QDS.h b/include/configs/BSC9132QDS.h
index d0e5a25..cf9c2db 100644
--- a/include/configs/BSC9132QDS.h
+++ b/include/configs/BSC9132QDS.h
@@ -525,7 +525,8 @@ combinations. this should be removed later
 #define CONFIG_SYS_FSL_ESDHC_ADDR	CONFIG_SYS_MPC85xx_ESDHC_ADDR
 #endif
 
-#define CONFIG_USB_EHCI  /* USB */
+#define CONFIG_USB_DEVTREE_FIXUP /* USB */
+#define CONFIG_USB_EHCI
 #ifdef CONFIG_USB_EHCI
 #define CONFIG_CMD_USB
 #define CONFIG_EHCI_HCD_INIT_AFTER_RESET
diff --git a/include/configs/MPC8308RDB.h b/include/configs/MPC8308RDB.h
index 955ce62..a6e9a05 100644
--- a/include/configs/MPC8308RDB.h
+++ b/include/configs/MPC8308RDB.h
@@ -333,6 +333,9 @@
 #define CONFIG_OF_BOARD_SETUP	1
 #define CONFIG_OF_STDOUT_VIA_ALIAS	1
 
+/* USB */
+#define CONFIG_USB_DEVTREE_FIXUP
+
 /* I2C */
 #define CONFIG_SYS_I2C
 #define CONFIG_SYS_I2C_FSL
diff --git a/include/configs/MPC8315ERDB.h b/include/configs/MPC8315ERDB.h
index ba952e3..f3edd75 100644
--- a/include/configs/MPC8315ERDB.h
+++ b/include/configs/MPC8315ERDB.h
@@ -377,6 +377,7 @@
 #undef CONFIG_PCI_SCAN_SHOW	/* show pci devices on startup */
 #define CONFIG_SYS_PCI_SUBSYS_VENDORID 0x1957	/* Freescale */
 
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #define CONFIG_SYS_SCCR_USBDRCM		3
 
diff --git a/include/configs/MPC837XEMDS.h b/include/configs/MPC837XEMDS.h
index df47888..d088444 100644
--- a/include/configs/MPC837XEMDS.h
+++ b/include/configs/MPC837XEMDS.h
@@ -386,7 +386,8 @@ extern int board_pci_host_broken(void);
 #define CONFIG_PCIE
 #define CONFIG_PQ_MDS_PIB	1 /* PQ MDS Platform IO Board */
 
-#define CONFIG_HAS_FSL_DR_USB	1 /* fixup device tree for the DR USB */
+#define CONFIG_USB_DEVTREE_FIXUP /* fixup device tree for the DR USB */
+#define CONFIG_HAS_FSL_DR_USB	1
 #define CONFIG_CMD_USB
 #define CONFIG_USB_STORAGE
 #define CONFIG_USB_EHCI
diff --git a/include/configs/MPC837XERDB.h b/include/configs/MPC837XERDB.h
index e77848e..2759893 100644
--- a/include/configs/MPC837XERDB.h
+++ b/include/configs/MPC837XERDB.h
@@ -677,6 +677,7 @@
  */
 #define CONFIG_ENV_OVERWRITE
 
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #define CONFIG_CMD_USB
 #define CONFIG_USB_STORAGE
diff --git a/include/configs/MPC8536DS.h b/include/configs/MPC8536DS.h
index 294be3b..2fa53f0 100644
--- a/include/configs/MPC8536DS.h
+++ b/include/configs/MPC8536DS.h
@@ -654,6 +654,7 @@
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_MPH_USB
 #ifdef CONFIG_HAS_FSL_MPH_USB
 #define CONFIG_USB_EHCI
diff --git a/include/configs/P1010RDB.h b/include/configs/P1010RDB.h
index f9776c0..4822699 100644
--- a/include/configs/P1010RDB.h
+++ b/include/configs/P1010RDB.h
@@ -744,6 +744,7 @@ extern unsigned long get_sdram_size(void);
 #define CONFIG_SYS_FSL_ESDHC_ADDR	CONFIG_SYS_MPC85xx_ESDHC_ADDR
 #endif
 
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #if defined(CONFIG_HAS_FSL_DR_USB)
diff --git a/include/configs/P1022DS.h b/include/configs/P1022DS.h
index 6235bbb..0277565 100644
--- a/include/configs/P1022DS.h
+++ b/include/configs/P1022DS.h
@@ -688,6 +688,7 @@
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #ifdef CONFIG_HAS_FSL_DR_USB
 #define CONFIG_USB_EHCI
diff --git a/include/configs/P1023RDB.h b/include/configs/P1023RDB.h
index bc479f6..6d135f6 100644
--- a/include/configs/P1023RDB.h
+++ b/include/configs/P1023RDB.h
@@ -280,6 +280,7 @@ extern unsigned long get_clock_freq(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #ifdef CONFIG_HAS_FSL_DR_USB
 #define CONFIG_USB_EHCI
diff --git a/include/configs/P2041RDB.h b/include/configs/P2041RDB.h
index b2e51b5..d3d0b13 100644
--- a/include/configs/P2041RDB.h
+++ b/include/configs/P2041RDB.h
@@ -628,6 +628,7 @@ unsigned long get_board_sys_clk(unsigned long dummy);
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #define CONFIG_HAS_FSL_MPH_USB
 
diff --git a/include/configs/T102xQDS.h b/include/configs/T102xQDS.h
index 951cbc4..3b2c0df 100644
--- a/include/configs/T102xQDS.h
+++ b/include/configs/T102xQDS.h
@@ -686,6 +686,7 @@ unsigned long get_board_ddr_clk(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #ifdef CONFIG_HAS_FSL_DR_USB
diff --git a/include/configs/T102xRDB.h b/include/configs/T102xRDB.h
index 4a0f5b2..3aff72f 100644
--- a/include/configs/T102xRDB.h
+++ b/include/configs/T102xRDB.h
@@ -683,6 +683,7 @@ unsigned long get_board_ddr_clk(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #ifdef CONFIG_HAS_FSL_DR_USB
diff --git a/include/configs/T1040QDS.h b/include/configs/T1040QDS.h
index 9e151da..e77c95a 100644
--- a/include/configs/T1040QDS.h
+++ b/include/configs/T1040QDS.h
@@ -569,6 +569,7 @@ unsigned long get_board_ddr_clk(void);
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #ifdef CONFIG_HAS_FSL_DR_USB
diff --git a/include/configs/T104xRDB.h b/include/configs/T104xRDB.h
index da65f56..bfd1ef1 100644
--- a/include/configs/T104xRDB.h
+++ b/include/configs/T104xRDB.h
@@ -626,6 +626,7 @@ $(SRCTREE)/board/freescale/t104xrdb/t1042d4_rcw.cfg
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #ifdef CONFIG_HAS_FSL_DR_USB
diff --git a/include/configs/T208xQDS.h b/include/configs/T208xQDS.h
index a0cecc6..87cda4e 100644
--- a/include/configs/T208xQDS.h
+++ b/include/configs/T208xQDS.h
@@ -733,6 +733,7 @@ unsigned long get_board_ddr_clk(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #ifdef CONFIG_USB_EHCI
 #define CONFIG_CMD_USB
 #define CONFIG_USB_STORAGE
diff --git a/include/configs/T208xRDB.h b/include/configs/T208xRDB.h
index 312b0eb..e7c7409 100644
--- a/include/configs/T208xRDB.h
+++ b/include/configs/T208xRDB.h
@@ -15,6 +15,7 @@
 #define CONFIG_T2080RDB
 #define CONFIG_ICS307_REFCLK_HZ 25000000  /* ICS307 ref clk freq */
 #define CONFIG_MMC
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_USB_EHCI
 #define CONFIG_FSL_SATA_V2
 
diff --git a/include/configs/T4240QDS.h b/include/configs/T4240QDS.h
index 1b94f64..00bdd69 100644
--- a/include/configs/T4240QDS.h
+++ b/include/configs/T4240QDS.h
@@ -528,6 +528,7 @@ unsigned long get_board_ddr_clk(void);
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_CMD_USB
 #define CONFIG_USB_STORAGE
 #define CONFIG_USB_EHCI
diff --git a/include/configs/corenet_ds.h b/include/configs/corenet_ds.h
index aef37dd..8cc581e 100644
--- a/include/configs/corenet_ds.h
+++ b/include/configs/corenet_ds.h
@@ -639,6 +639,7 @@
 /*
 * USB
 */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 #define CONFIG_HAS_FSL_MPH_USB
 
diff --git a/include/configs/ls2080aqds.h b/include/configs/ls2080aqds.h
index ba84248..366be59 100644
--- a/include/configs/ls2080aqds.h
+++ b/include/configs/ls2080aqds.h
@@ -387,6 +387,7 @@ unsigned long get_board_ddr_clk(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_XHCI_USB
 #define CONFIG_USB_XHCI
 #define CONFIG_USB_XHCI_FSL
diff --git a/include/configs/ls2080ardb.h b/include/configs/ls2080ardb.h
index 116dbcd..aa0689b 100644
--- a/include/configs/ls2080ardb.h
+++ b/include/configs/ls2080ardb.h
@@ -305,6 +305,7 @@ unsigned long get_board_sys_clk(void);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_XHCI_USB
 #define CONFIG_USB_XHCI
 #define CONFIG_USB_XHCI_FSL
diff --git a/include/configs/p1_p2_rdb_pc.h b/include/configs/p1_p2_rdb_pc.h
index 60bedaa..718d9de 100644
--- a/include/configs/p1_p2_rdb_pc.h
+++ b/include/configs/p1_p2_rdb_pc.h
@@ -895,6 +895,7 @@
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #if defined(CONFIG_HAS_FSL_DR_USB)
diff --git a/include/configs/p1_twr.h b/include/configs/p1_twr.h
index 77ba2d8..fde397e 100644
--- a/include/configs/p1_twr.h
+++ b/include/configs/p1_twr.h
@@ -426,6 +426,7 @@ extern unsigned long get_board_sys_clk(unsigned long dummy);
 /*
  * USB
  */
+#define CONFIG_USB_DEVTREE_FIXUP
 #define CONFIG_HAS_FSL_DR_USB
 
 #if defined(CONFIG_HAS_FSL_DR_USB)